﻿using Supercell.GUT.Logic.Message.Attributes;
using Supercell.GUT.Titan.Message;

namespace Supercell.GUT.Logic.Message.Account;

[VersionedMessage(10103)]
public class CreateAccountMessage : VersionedMessage
{
    public string? FacebookId { get; set; }
    public string? GameCenterId { get; set; }

    public CreateAccountMessage() : base(0)
    {
        this.FacebookId = null;
        this.GameCenterId = null;
    }
    
    public CreateAccountMessage(int messageVersion) : base(messageVersion)
    {
        this.FacebookId = null;
        this.GameCenterId = null;
    }

    public override void Destruct()
    {
        base.Destruct();
        
        this.FacebookId = null;
        this.GameCenterId = null;
    }

    public override int GetMessageType()
    {
        return 10103;
    }

    public override int GetServiceNodeType()
    {
        return 1;
    }

    public override void Encode()
    {
        base.Encode();

        this.ByteStream.WriteString(null);
        this.ByteStream.WriteString(this.FacebookId);
        this.ByteStream.WriteString(this.GameCenterId);
        this.ByteStream.WriteString(null);
        this.ByteStream.WriteString(null);
    }

    public override void Decode()
    {
        base.Decode();

        this.ByteStream.ReadString();
        this.FacebookId = this.ByteStream.ReadString();
        this.GameCenterId = this.ByteStream.ReadString();
        this.ByteStream.ReadString();
        this.ByteStream.ReadString();
    }
}
